#include <string>
#include <iostream>
#include <list>

#include <arc/notify.h>
#include <arc/mdsquery.h>
#include <arc/resource.h>

int main() {

	SetNotifyLevel(DEBUG);
	URL url("ldap://quark.hep.lu.se:2135");

	std::list<Queue> queueinfo;
	try {
		queueinfo = GetQueueInfo(url);
	} catch(ARCLibError e) {
		std::cout << e.what() << std::endl;
	}

	std::cout << "Found queues: " << queueinfo.size() << std::endl;

	if (queueinfo.size()>0) {
		std::list<Queue>::iterator it;
		for (it = queueinfo.begin(); it != queueinfo.end(); it++) {
			std::cout << "Queue: " << it->name << std::endl;
			std::cout << "Status: " << it->status << std::endl;
			std::cout << "Comment: " << it->comment << std::endl;
			std::cout << "On cluster: " << it->cluster.hostname << std::endl;
		}
	}
}
