package se.umu.jobsubmission.impl.informationfinder.test; 

import java.util.Iterator; 
import java.util.List; 
import java.util.LinkedList; 

import org.nordugrid.job.mds.ARCMDSDiscovery;
import org.nordugrid.job.mds.ARCMDSDiscoveryError;
import org.globus.mds.glue.GLUECERPType;

import se.umu.jobsubmission.impl.informationfinder.InformationFinder; 
import se.umu.jobsubmission.impl.informationfinder.ResourceFinder; 
import se.umu.jobsubmission.impl.informationfinder.ARCResource; 


public class TestInformationFinder {

    private static String finder = 
        "se.umu.jobsubmission.impl.informationfinder.ARCResourceFinder"; 
    private static String fetcher = 
        "se.umu.jobsubmission.impl.informationfinder.ARCInformationFetcher"; 
    private static String converter = 
        "se.umu.jobsubmission.impl.informationfinder.ARCInformationConverter"; 
    
    public static void main(String[] args) {
        try {
            if(args.length < 2) {
                System.err.println("Arguments: (IS_URI)+ #Threads"); 
                System.exit(0); 
            }

            List indexServers = new LinkedList(); 
            for(int i = 0; i < args.length - 1; i++) 
                indexServers.add(args[i]); 

            int noThreads = Integer.parseInt(args[args.length-1]); 

            InformationFinder infoFinder = new InformationFinder(noThreads, 
                    finder, 
                    fetcher,
                    converter, 
                    12000, 
					indexServers); 
            
            System.out.println("Searching for information"); 
            List l2 = infoFinder.getResourceInfo(indexServers);

            if(l2 == null) {
                System.err.println("No resources found"); 
                System.exit(0); 
            }

            System.out.println("Found resources"); 
            Iterator it = l2.iterator(); 
            while(it.hasNext()) {
                System.out.println("\n\t<:: Resource ::>"); 
                GLUECERPType resource = (GLUECERPType) it.next();                 
                System.out.println(resource.getCluster(0).getSubCluster(0).getHost(0).getName()); 
                /*
                ARCResource resource = (ARCResource) it.next(); 
                resource.printIt(); */
                System.out.println(" " + it.next()); 
            }
            
            infoFinder.shutdown(); 

        } catch(Exception e) {
            e.printStackTrace(); 
        }
    }
}

